import java.awt.*;
import java.util.*;

class DrawPad extends Canvas {

   int lastx, lasty;
   int lastIndex = 0; //used to mark our drawing vector
   Vector lines = new Vector();
   ChatApplet c;  //the client that created the DrawPanel
   Image i; //for double buffering
   Graphics db; //used to access the offscreen buffer

   public DrawPad(ChatImpl c) {
	super();
	this.c=c;
   }

   public void paint(Graphics g) {
	if(i!=null)
	   g.drawImage(i,0,0,this);
	else{
	   g.drawString("Initialiazing...", 5,30);
	   render();
	}
   }
   public void render() {
	Line l;

	if(i==null) {
	   i = this.createImage(400,400);
	   db = i.getGraphics();
	   db.setColor(Color.white);
	   db.fillRect(0,0,400,400);
	   db.setColor(Color.red);
	   db.drawRect(0,0,400-1,400-1);
	   db.setColor(Color.black);
	}
	for(int i = lastIndex; i < lines.size(); i++){
	   l = (Line)lines.elementAt(i);
	   db.drawLine(l.x, l.y, l.dx, l.dy);
	}
	lastIndex = lines.size();
	repaint();

   }
   public void clearScreen(){
	i = null;
	lines = new Vector();
	lastIndex=0;
	render();
   }
   public void update(Graphics g) {
	paint(g);
   }

   public boolean mouseDown(Event e, int x, int y) {
      lastx=x;
      lasty=y;
      return true;
   }

   public boolean mouseDrag(Event e, int x, int y){
      getGraphics().drawLine(lastx,lasty,x,y);
      drawLine(x,y);
      return true;
   }

   public boolean mouseUp(Event e, int x, int y){
      getGraphics().drawLine(lastx,lasty,x,y);
      drawLine(x,y);
      return true;
   }

   void drawLine(int x, int y) {

      if((Math.abs(lastx-x)>1)||(Math.abs(lasty-y)>1)){
         Line l = new Line(x,y,lastx,lasty);
	 addLine(l);
         c.sendMessage(l);
         System.out.println("linea enviada");
         lastx=x;
         lasty=y;
      }
   }
   public void addLine(Line l) {
	lines.addElement(l);
	render();	
   }
}
