
import java.rmi.*;
import java.rmi.server.*;
import java.rmi.registry.*;
import java.util.*;

public 	class ChatServerImpl 
extends UnicastRemoteObject 
implements ChatServer {

	//The chatters Vector maintains a list of
	//all registered Chat clients
	private Vector chatters = new Vector();

	public ChatServerImpl() throws RemoteException {
	   super();
	   System.out.println("Initializing Server...");
	}

	public static void main(String args[]){

	   Registry reg;
           String list[];
	   //A security manager must be set to allow stub
  	   //loading over the network
	   System.setSecurityManager(new RMISecurityManager());
	   try {
	      //create an instance of the ChatServerImpl object to
	      //export
	      ChatServer cs = new ChatServerImpl();

	      //create a new registry running on port 5050
	      //reg = LocateRegistry.createRegistry(1200);
	      LocateRegistry.createRegistry(1200);
              System.out.println("Registro creado...");

	      //bind our cs object to this registry
	      //reg.bind("//"+java.net.InetAddress.getLocalHost().getHostAddress()+ ":" + "1200/" + "ChatServerImpl", cs);
              
              //list = reg.list();
              //for (int c=0; c<list.length; c++) 
              //  System.out.println("Registrado: "+ list[c]);

              Naming.rebind("//" + java.net.InetAddress.getLocalHost().getHostAddress() + ":" + "1200" + "/ChatServerImpl",cs);
	      System.out.println("Server Ready");
              list = Naming.list("//"+java.net.InetAddress.getLocalHost().getHostAddress()+":"+ "1200/");
              for (int c=0; c<list.length; c++) 
                System.out.println("Registrado: "+ list[c]);
	   } 

           //   catch (AlreadyBoundException e) {
	   //   System.out.println("This name is already bound: " + e);
	   //   System.exit(0);
	   //} 
             catch (RemoteException e) {
	      System.out.println("General ChatServer Error: " + e);
	      System.exit(0);
	   } catch (Exception e) {
             e.printStackTrace();
           } 
	}

	synchronized public void register(Chat c, String name) {
	   chatters.addElement(new Talker(c,name)); 
	}
	public String[] listChatters() {
	      String list[] = new String[chatters.size()];
	      Talker c;

	      for(int i=0; i< list.length; i++){
		   c=(Talker)chatters.elementAt(i);
		   list[i] = c.getChatterName();
	      }
	      return list;
	}

	synchronized public void postMessage(Message m){
	   Talker t;
	   for(int i=0; i < chatters.size() ; i++){
	      t = (Talker)chatters.elementAt(i);
	      if(!t.addMessage(m))
	        chatters.removeElementAt(i--);
	   }
		
	}
}
